from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField
from wtforms.validators import DataRequired, ValidationError
from minibase.database.models import Person_role
from minibase.database.models import Company_legal_entity, Company_relation
from minibase.database.models import Industry


class compIndustryForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Industry')

    # Queries to be made in order to validate the form : If Relation Type exitst  # Case Insensistive
    def validate_name(self, name):
        industry_query = Industry.query.filter(Industry.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if industry_query:
            raise ValidationError('That Industry Type is already registered')


class compRelationForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Relation')

    # Queries to be made in order to validate the form : If Relation Type exitst  # Case Insensistive
    def validate_name(self, name):
        relation_query = Company_relation.query.filter(Company_relation.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if relation_query:
            raise ValidationError('That Relation Type is already registered')


class compLegalEntityForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Legal Entity')

    # Queries to be made in order to validate the form : If Legal Entity exitst  # Case Insensistive
    def validate_name(self, name):
        legal_entity_query = Company_legal_entity.query.filter(Company_legal_entity.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if legal_entity_query:
            raise ValidationError('That Legal Entity is already registered')


class personRoleForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Role')

    # Queries to be made in order to validate the form : If Person Role exitst  # Case Insensistive
    def validate_name(self, name):
        person_role_query = Person_role.query.filter(Person_role.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if person_role_query:
            raise ValidationError('That Person Role is already registered')


class personCompetenceForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Role')

    # Queries to be made in order to validate the form : If Person Role exitst  # Case Insensistive
    def validate_name(self, name):
        person_competence_query = Person_role.query.filter(Person_role.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if person_competence_query:
            raise ValidationError('That Person Conpetence is already registered')


class statusRegisterForm(FlaskForm):  # Defines the form class to be used for the user registretion
    # Decalarion of the fields for the form and it's propereties
    name = StringField('Name', validators=[DataRequired()])
    description = StringField('Description', validators=[DataRequired()])
    submit = SubmitField('Register Status')

    # Queries to be made in order to validate the form : If Person Role exitst  # Case Insensistive
    def validate_name(self, name):
        person_competence_query = Status.query.filter(Status.name.ilike(name.data)).first()  # Database Querry ilike means case insessitive
        if person_competence_query:
            raise ValidationError('That Status is already registered')
